VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRTF_Utils"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'------------------------------------------------------------------
'
'     clsRTF_Utils         Utilities fr Richtextbox Class
'
'     Autor    peter.k.sauer@web.de (pks)
'     created  06.05.2004
'     update   12.05.2004
'                                                  Quelle
' Eigenschaften
'     SelIndentValueStep   einrcken um (Twips)
'     SelIndentValueMininamle links Minimum
'     CachTab              Tab Taste einfangen
'
' Methoden
'     Init                 bergabe der RTF Box    pks
'     PrintRTFText         RTF Dokument drucken    internet/pks
'                          mit Events bei NewPage/EndDoc
'     SetSelBackColor                              http://edeca.net/
'     GetSelBackColor                              moreinfo.php?f=rtbhilite
'     SetSelForeColor                              pks
'     PrintLeft, -Center, -Right  drucken          pks
'     FontSet              direkt einstellen       pks
'     SelFontWithCDLF      ber CommonDialog       pks
'     SetSelForeColor      direkt einstellen       pks
'     SelForeColorWithCDLg ber CommonDialog       pks
'     SelBackColor         direkt einstellen       pks
'     SelBackColorWithCDLG ber CommonDialog       pks
'     SelInvers            Fore- BackColor Change  pks
'     SearchWords          Begriffe suchen und     pks
'                          markieren, vorwrts, rckwrts
'     ColorizeWords        Begriffe einfrben      pks
'     CopyToClipBoard      kopieren -> Clipboard   pks
'     InsertFromClipBoard  einfgen <- Clipboard   pks
'     SelIndentAdd         Einzug vergrssern      pks
'     SelIndentSub         Einzug verkleinern      pks
'     SelBullet            Aufzhlungen on/off     pks
'     SelAlign             Left, Right, Center     pks
'     SetTabs              Tabs setzen             pks
'-------------------------------------------------------------------

Option Explicit

'------------------------------------- Definitionen fr SelBackColor
' General declarations
Private Const LF_FACESIZE = 32
Private Const GWL_STYLE = (-16)
Private Const SCF_SELECTION = &H1&

' Font Back Color
Private Const CFM_BACKCOLOR = &H4000000
Private Const CFE_AUTOBACKCOLOR = CFM_BACKCOLOR

' CharFormat structure, passed with SendMessage to the
' control
Private Type CHARFORMAT2
    cbSize As Integer
    wPad1 As Integer
    dwMask As Long
    dwEffects As Long
    yHeight As Long
    yOffset As Long
    crTextColor As Long
    bCharSet As Byte
    bPitchAndFamily As Byte
    szFaceName(0 To LF_FACESIZE - 1) As Byte
    wPad2 As Integer
    wWeight As Integer
    sSpacing As Integer
    crBackColor As Long
    lLCID As Long
    dwReserved As Long
    sStyle As Integer
    wKerning As Integer
    bUnderlineType As Byte
    bAnimation As Byte
    bRevAuthor As Byte
    bReserved1 As Byte
End Type

' Window messages
Private Const WM_USER = &H400

' Edit messages
Private Const EM_SETCHARFORMAT = (WM_USER + 68)
Private Const EM_SETBKGNDCOLOR = (WM_USER + 67)
Private Const EM_GETCHARFORMAT = (WM_USER + 58)
Private Const WM_SETTEXT = &HC

'---------------------------------------- Definitionen fr PrintRTF
Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type CharRange
   cpMin As Long     ' First character of range (0 for start of doc)
   cpMax As Long     ' Last character of range (-1 for end of doc)
End Type

Private Type FormatRange
   hdc As Long       ' Actual DC to draw on
   hdcTarget As Long ' Target DC for determining text formatting
   rc As RECT        ' Region of the DC to draw to (in twips)
   rcPage As RECT    ' Region of the entire DC (page size) (in twips)
   chrg As CharRange ' Range of text to draw (see above declaration)
End Type

'Private Const WM_USER As Long = &H400 '(bereits definiert)
Private Const EM_FORMATRANGE As Long = WM_USER + 57
Private Const EM_SETTARGETDEVICE As Long = WM_USER + 72
Private Const PHYSICALOFFSETX As Long = 112
Private Const PHYSICALOFFSETY As Long = 113

Private Declare Function GetDeviceCaps Lib "gdi32" ( _
                         ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                         (ByVal hwnd As Long, ByVal Msg As Long, ByVal wp As Long, _
                         lp As Any) As Long
Private Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" _
                         (ByVal lpDriverName As String, ByVal lpDeviceName As String, _
                         ByVal lpOutput As Long, ByVal lpInitData As Long) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal _
                         lOleColor As Long, ByVal lHPalette As Long, _
                         lColorRef As Long) As Long

'-------------------------------------- berprfen Tab Taste
Private Declare Function GetAsyncKeyState Lib "user32" _
                        (ByVal vKey As Long) As tagWORD

Private Type tagWORD
  lByte As Byte
  hByte As Byte
End Type

Private Const VK_TAB = &H9
Private Const VK_SHIFT = &H10
'----------------------------------------------------------------------------
Private CDLG As Object                       'zur Auswahl von Schrift, Farbe
Private WithEvents RTF As RichTextBox        'wird im Init bergeben
Attribute RTF.VB_VarHelpID = -1

Public Event NewPage(PageNo As Long)         'Event vor Seitenwechsel
Public Event EndDoc(PageNo As Long)          'Event vor Druckende

Public Enum rtfFontAttributs                 'Enum fr FontSet
   rtfPrintBold = 1
   rtfPrintItalic = 2
   rtfPrintUnderline = 4
End Enum
   
Public Enum rtfAlignAttributs
   rtfAlignLeft = 1
   rtfAlignRight = 2
   rtfAlignCenter = 3
End Enum
   
Private LeftOffset As Long                   'phys. Druckrnder
Private TopOffset As Long

Private mvarSelIndentValueStep As Single     'Step in Twips bei Indent Default 20 Pixel
Private mvarSelIndentValueMinimale As Single 'Minimale bei Indent Default = 10 Pixel
Private mvarCatchTab As Boolean              'Tab Taste einfangen Default = True

Public Property Let CatchTab(ByVal vData As Boolean)
    mvarCatchTab = vData
End Property

Public Property Get CatchTab() As Boolean
    CatchTab = mvarCatchTab
End Property

Public Property Let SelIndentValueMinimale(ByVal vData As Single)
    mvarSelIndentValueMinimale = vData
End Property

Public Property Get SelIndentValueMinimale() As Single
    SelIndentValueMinimale = mvarSelIndentValueMinimale
End Property

Public Property Let SelIndentValueStep(ByVal vData As Single)
    mvarSelIndentValueStep = vData
End Property

Public Property Get SelIndentValueStep() As Single
    SelIndentValueStep = mvarSelIndentValueStep
End Property

'Initialisieren mit bergabe der RTF
Public Sub Init(RTFBox As RichTextBox)

      Set RTF = RTFBox
End Sub


' drucken RichTextBox.Text formatiert
' ScaleMode bezieht sich auf Margins
Public Function PrintRTFText(LeftMarginWidth As Long, TopMarginHeight As Long, _
                        RightMarginWidth As Long, BottomMarginHeight As Long, _
                        ScaleMode As Long, _
                        Optional OnlyMarkedText As Boolean = False) As Boolean
   
   Dim LeftMargin As Long, TopMargin As Long
   Dim RightMargin As Long, BottomMargin As Long
   Dim fr As FormatRange
   Dim rcDrawTo As RECT, rcPage As RECT
   Dim TextLength As Long
   Dim NextCharPosition As Long
   Dim R As Long, SaveScaleMode As Long
   Dim PageNo As Long
   
      'nur markierten Text drucken
      If OnlyMarkedText Then
         If RTF.SelLength = 0 Then
            Exit Function
         End If
      End If
   
      ' Start a print job to get a valid Printer.hDC
      Printer.Print ""
      SaveScaleMode = Printer.ScaleMode
      Printer.ScaleMode = vbTwips
      
      ' Get the offsett to the printable area on the page in twips
      LeftOffset = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
                   PHYSICALOFFSETX), vbPixels, vbTwips)
      TopOffset = Printer.ScaleY(GetDeviceCaps(Printer.hdc, _
                  PHYSICALOFFSETY), vbPixels, vbTwips)
      
      ' Calculate the Left, Top, Right, and Bottom margins
      With Printer
         LeftMargin = .ScaleX(LeftMarginWidth, ScaleMode, vbTwips) _
                       - (LeftOffset * 2)
         TopMargin = .ScaleY(TopMarginHeight, ScaleMode, vbTwips) _
                      - (TopOffset * 2)
         RightMargin = (Printer.Width - .ScaleX(RightMarginWidth, _
                                        ScaleMode, vbTwips)) - LeftOffset
         BottomMargin = (Printer.Height - .ScaleY(BottomMarginHeight, _
                                        ScaleMode, vbTwips)) - TopOffset
      End With
      
      ' Set printable area rect
      rcPage.Left = 0
      rcPage.Top = 0
      rcPage.Right = Printer.ScaleWidth
      rcPage.Bottom = Printer.ScaleHeight

      ' Set rect in which to print (relative to printable area)
      rcDrawTo.Left = LeftMargin
      rcDrawTo.Top = TopMargin
      rcDrawTo.Right = RightMargin
      rcDrawTo.Bottom = BottomMargin

      ' Set up the print instructions
      fr.hdc = Printer.hdc          ' Use the same DC for measuring and rendering
      fr.hdcTarget = Printer.hdc    ' Point at printer hDC
      fr.rc = rcDrawTo              ' Indicate the area on page to draw to
      fr.rcPage = rcPage            ' Indicate entire size of page
      fr.chrg.cpMin = 0             ' Indicate start of text through
      fr.chrg.cpMax = -1            ' end of the text

      ' Get length of text in RTF
      TextLength = Len(RTF.Text)

      ' nur markierten Text bergeben
      If OnlyMarkedText Then
         TextLength = RTF.SelLength
         fr.chrg.cpMin = RTF.SelStart
         fr.chrg.cpMax = RTF.SelStart + TextLength
      End If

      ' Loop printing each page until done
      Do
         ' Print the page by sending EM_FORMATRANGE message
         NextCharPosition = SendMessage(RTF.hwnd, EM_FORMATRANGE, True, fr)
         If NextCharPosition >= TextLength Then
            Exit Do                       'If done then exit
         End If
         fr.chrg.cpMin = NextCharPosition ' Starting position for next page
         
         PageNo = PageNo + 1
         RaiseEvent NewPage(PageNo)       'einfgen Kopf + Fuss ermglichen
         
         Printer.NewPage                  ' Move on to next page
         
         Printer.Print ""                 ' Re-initialize hDC
         fr.hdc = Printer.hdc
         fr.hdcTarget = Printer.hdc
      Loop

      ' Commit the print job
      PageNo = PageNo + 1
      RaiseEvent EndDoc(PageNo)           'einfgen Kopf + Fuss ermglichen
      Printer.EndDoc

      ' Allow the RTF to free up memory
      R = SendMessage(RTF.hwnd, EM_FORMATRANGE, False, ByVal CLng(0))
      Printer.ScaleMode = SaveScaleMode
      
      PrintRTFText = True
End Function

'Font einstellen fr Ergnzungen
Public Sub FontSet(FontName As String, Optional FontSize As Long = 0, _
                                       Optional FontAttributes As rtfFontAttributs = 0)

      Printer.FontName = FontName
      
      If FontSize > 0 Then
         Printer.FontSize = FontSize
      End If
      
      If (FontAttributes And rtfPrintBold) = rtfPrintBold Then
         Printer.FontBold = True
      Else
         Printer.FontBold = False
      End If
      
      If (FontAttributes And rtfPrintItalic) = rtfPrintItalic Then
         Printer.FontItalic = True
      Else
         Printer.FontItalic = False
      End If
      
      If (FontAttributes And rtfPrintUnderline) = rtfPrintUnderline Then
         Printer.FontUnderline = True
      Else
         Printer.FontUnderline = False
      End If
End Sub

'linksbndig einen Text drucken
Public Sub PrintLeft(Txt As String, X As Long, Y As Long, ScaleMode As Long)

      Printer.CurrentX = Printer.ScaleX(X, ScaleMode, vbTwips) - LeftOffset
      Printer.CurrentY = Printer.ScaleY(Y, ScaleMode, vbTwips) - TopOffset
      Printer.Print Txt
End Sub

'linksbndig einen Text drucken
Public Sub PrintRight(Txt As String, X As Long, Y As Long, ScaleMode As Long)

      Printer.CurrentX = Printer.ScaleX(X, ScaleMode, vbTwips) - _
                         LeftOffset - Printer.TextWidth(Txt)
      Printer.CurrentY = Printer.ScaleY(Y, ScaleMode, vbTwips) - TopOffset
      Printer.Print Txt
End Sub

'zentriert einen Text drucken
Public Sub PrintCenter(Txt As String, X As Long, Y As Long, ScaleMode As Long)

      Printer.CurrentX = Printer.ScaleX(X, ScaleMode, vbTwips) - _
                         LeftOffset - (Printer.TextWidth(Txt) / 2)
      Printer.CurrentY = Printer.ScaleY(Y, ScaleMode, vbTwips) - TopOffset
      Printer.Print Txt
End Sub

'Selektierten Text einfrben
Public Sub SetSelForeColor(Color As Long)

   Dim i As Long, c As Long

      With RTF
         On Error Resume Next
         c = .SelColor
         If .SelLength = 0 Then
            Exit Sub
         End If
         i = .SelLength
         .SelColor = Color
         .SelLength = 0
         .SelStart = .SelStart + i
         .SelColor = c
      End With
End Sub

'Selektierten Text Invers darstellen
Public Function SetSelInversColor()

   Dim i As Long, j As Long
   Dim ForeColor As Long, BackColor As Long

      With RTF
         i = .SelLength
         j = .SelStart
         If i = 0 Then
            Exit Function
         End If
         On Error Resume Next
         
         ForeColor = .SelColor
         If Err.Number <> 0 Then
            Exit Function
         End If
         
         BackColor = GetSelBackColor
         If Err.Number <> 0 Then
            Exit Function
         End If
         
         'bist du noch Jungfrau ?
         If (ForeColor = 0) And (BackColor = 0) Then
            BackColor = vbWhite
         End If
         
         'Backcolor neu setzen
         SetSelBackColor ForeColor
         .SelStart = j
         .SelLength = i
         'Forecolor neu setzen
         SetSelForeColor BackColor
      End With
      
Fehler:
      SetSelInversColor = True
      On Error GoTo 0
End Function

'Worte im Text einfrben
Public Sub ColorizeWords(ColorizeWord As String, Color As Long, _
                         Optional SetForeColor As Boolean = True, _
                         Optional DoTextCompare As Boolean = True, _
                         Optional OnlyWholeWords As Boolean = True)

   Dim i As Long, j As Long
   Dim SelStart As Long
   Dim WordLen As Long, TextLen As Long
   Dim DoIt As Boolean
      
      SelStart = RTF.SelStart
      WordLen = Len(ColorizeWord)
      TextLen = Len(RTF.Text)
      i = 1
      RTF.Visible = False
      Do
         If DoTextCompare Then
            j = InStr(i, RTF.Text, ColorizeWord, vbTextCompare)
         Else
            j = InStr(i, RTF.Text, ColorizeWord, vbBinaryCompare)
         End If
         If j = 0 Then
            Exit Do
         End If
         
         DoIt = True
         If OnlyWholeWords Then
            If j > 1 Then
               If Mid$(RTF.Text, j - 1, 1) > Chr(32) Then
                  DoIt = False
               End If
            End If
            If (j + WordLen) < TextLen Then
               If Mid$(RTF.Text, j + WordLen, 1) > Chr(32) Then
                  DoIt = False
               End If
            End If
         End If
         
         RTF.SelStart = j - 1
         RTF.SelLength = WordLen
         If DoIt Then
            If SetForeColor Then
               SetSelForeColor Color
            Else
               SetSelBackColor Color
            End If
         End If
         i = j + WordLen
      Loop
      RTF.SelLength = 0
      RTF.SelStart = SelStart
      RTF.Visible = True
End Sub


'Wort im Text suchen
Public Function SearchWords(SearchFor As String, _
                            Optional DoTextCompare As Boolean = True, _
                            Optional OnlyWholeWords As Boolean = True, _
                            Optional SearchForwarding As Boolean = True) As Boolean

   Dim i As Long, j As Long
   Dim WordLen As Long, TextLen As Long
   Dim DoIt As Boolean
      
      WordLen = Len(SearchFor)
      TextLen = Len(RTF.Text)
      
      If DoTextCompare Then
         If UCase(RTF.SelText) = UCase(SearchFor) Then
            j = WordLen
         End If
      Else
         If RTF.SelText = SearchFor Then
            j = WordLen
         End If
      End If
      
      If SearchForwarding Then
         i = RTF.SelStart + 1 + RTF.SelLength
      Else
         i = RTF.SelStart
      End If
      
      RTF.Visible = False
      RTF.SelLength = 0
      
      Do
         If i <= 0 Then
            RTF.SelStart = 0
            Exit Do
         ElseIf i > TextLen Then
            RTF.SelStart = TextLen
            Exit Do
         End If
         
         If SearchForwarding Then
            If DoTextCompare Then
               j = InStr(i, RTF.Text, SearchFor, vbTextCompare)
            Else
               j = InStr(i, RTF.Text, SearchFor, vbBinaryCompare)
            End If
         Else
            If DoTextCompare Then
               j = InStrRev(RTF.Text, SearchFor, i, vbTextCompare)
            Else
               j = InStrRev(RTF.Text, SearchFor, i, vbBinaryCompare)
            End If
         End If
         
         If j = 0 Then
            Exit Do
         End If
         
         DoIt = True
         If OnlyWholeWords Then
            If j > 1 Then
               If Mid$(RTF.Text, j - 1, 1) > Chr(32) Then
                  DoIt = False
               End If
            End If
            If (j + WordLen) < TextLen Then
               If Mid$(RTF.Text, j + WordLen, 1) > Chr(32) Then
                  DoIt = False
               End If
            End If
         End If
         
         If DoIt Then
            RTF.SelStart = j - 1
            RTF.SelLength = WordLen
            SearchWords = True
            Exit Do
         End If
         If SearchForwarding Then
            i = j + WordLen
         Else
            i = j - WordLen
         End If
      Loop
      RTF.Visible = True
End Function

'liefert Hintergrundfarbe SelText
Public Function GetSelBackColor() As OLE_COLOR
   
   Dim udtChar As CHARFORMAT2
   Dim RTFhwnd As Long
   
      RTFhwnd = RTF.hwnd
   
      ' Set BackColor mask
      udtChar.dwMask = CFM_BACKCOLOR
      udtChar.cbSize = Len(udtChar)
      ' Get character format structure from selection
      SendMessage RTFhwnd, EM_GETCHARFORMAT, SCF_SELECTION, udtChar
      ' Return the BackColour of the selection
      
      GetSelBackColor = udtChar.crBackColor
End Function

Public Function SetSelBackColor(ByVal NewSelFontBackColor As OLE_COLOR)

   Dim udtChar As CHARFORMAT2
   Dim RTFhwnd As Long
   
      RTFhwnd = RTF.hwnd
   
      ' Set the mask
      udtChar.dwMask = CFM_BACKCOLOR
      
      ' If the new backcolour is set to -1 then we set the
      ' RichTextbox backcolour to be "auto"
      If NewSelFontBackColor = -1 Then
         udtChar.dwEffects = CFE_AUTOBACKCOLOR
         udtChar.crBackColor = -1
      Else
         ' Set the BackColour to the new colour
         udtChar.crBackColor = TranslateColor(NewSelFontBackColor)
      End If
      
      ' We need to pass the size of the structure as a
      ' part of the structure.
      udtChar.cbSize = Len(udtChar)
      
      ' Send the SET message and the new character format
      ' structure to the RichTextbox
      SendMessage RTFhwnd, EM_SETCHARFORMAT, SCF_SELECTION, udtChar
End Function

' Used by the SetSelBackColor function, no need for the
' end user to touch this function
Private Function TranslateColor(ByVal clr As OLE_COLOR, Optional hPal As Long = 0) As Long

      If OleTranslateColor(clr, hPal, TranslateColor) Then
         TranslateColor = -1
      End If
End Function

' Pass this function a Colour in the form R*B*G and it will
' return the individual R G B components, useful for translating
' the return value of a common dialog colour picker or the
' GetSelBackColor function
Public Sub GetRGB(ByVal Colour, ByRef R, ByRef G, ByRef B)
   
   R = Colour Mod 256
   Colour = Colour \ 256
   G = Colour Mod 256
   Colour = Colour \ 256
   B = Colour Mod 256
End Sub

'Markierten Bereich formatiert kopieren
Public Function CopyToClipboardRtf() As Boolean

      If RTF.SelLength = 0 Then
         Exit Function
      End If
      
      Clipboard.Clear
      Clipboard.SetText RTF.SelRTF, vbCFRTF
      CopyToClipboardRtf = True
End Function

'formatiert einfgen aus Clipboard
Public Function InsertFromClipboardRtf() As Boolean

      If Not Clipboard.GetFormat(vbCFRTF) Then
         Exit Function
      End If
      
      RTF.SelLength = 0
      RTF.SelText = Clipboard.GetText(vbCFRTF)
      RTF.SelLength = 0
      InsertFromClipboardRtf = True
End Function

'Schriftart ber CommonDialog whlen
Public Function SelFontWithCDLG() As Boolean

   Const mcdlCFBoth = &H3
   Const mcdlCFEffects = &H100
   
     If RTF.SelLength = 0 Then
         Exit Function
      End If

      With CDLG
         On Error Resume Next
         .CancelError = True
         .Flags = mcdlCFBoth Or mcdlCFEffects
         .FontName = RTF.SelFontName
         .FontSize = RTF.SelFontSize
         .FontBold = RTF.SelBold
         .FontItalic = RTF.SelItalic
         .FontStrikethru = RTF.SelStrikeThru
         .FontUnderline = RTF.SelUnderline
         
         On Error GoTo Abbruch
         .ShowFont
         RTF.SelFontName = .FontName
         RTF.SelFontSize = .FontSize
         RTF.SelBold = .FontBold
         RTF.SelItalic = .FontItalic
         RTF.SelStrikeThru = .FontStrikethru
         RTF.SelUnderline = .FontUnderline
      End With
      RTF.SelLength = 0
      
Abbruch:
      SelFontWithCDLG = True
End Function

'ForeColor ber CommonDialog setzen
Public Function SelForeColorWithCDLG()

      SelForeColorWithCDLG = SelColorWithCDLG(True)
End Function

'BackColor ber CommonDialog setzen
Public Function SelBackColorWithCDLG()

      SelBackColorWithCDLG = SelColorWithCDLG(False)
End Function


'Farben ber CommonDialog setzen
Private Function SelColorWithCDLG(SelForeColor As Boolean) As Boolean
   
   Const mcdlCCRGBInit = &H1
      
      If RTF.SelLength = 0 Then
         Exit Function
      End If
      
      On Error Resume Next
      With CDLG
         .CancelError = True
         .Flags = mcdlCCRGBInit
         
         On Error Resume Next
         If SelForeColor Then
            'aktuelle (Sel)ForeColor Farbe
            .Color = RTF.SelColor
         Else
            'aktuelle (Sel)BackColor Farbe
            .Color = GetSelBackColor
         End If
         On Error GoTo Abbruch
         
         .ShowColor
         
         If SelForeColor Then
            SetSelForeColor .Color
         Else
            SetSelBackColor .Color
         End If
      End With
      RTF.SelLength = 0

Abbruch:
      On Error GoTo 0
      SelColorWithCDLG = True
End Function

'linken Rand einstellen, vergrssern
Public Function SelIndentAdd() As Boolean

   Dim i As Long
   
      If RTF.SelLength = 0 Then
         Exit Function
      End If
      
      i = RTF.SelIndent + mvarSelIndentValueStep
      If i < mvarSelIndentValueMinimale Then
         i = mvarSelIndentValueMinimale
      End If
      
      RTF.SelIndent = i
      SelIndentAdd = True
End Function

'linken Rand einstellen, verkleinern
Public Function SelIndentSub() As Boolean

   Dim i As Long
   
      If RTF.SelLength = 0 Then
         Exit Function
      End If
      
      i = RTF.SelIndent - mvarSelIndentValueStep
      If i < mvarSelIndentValueMinimale Then
         i = mvarSelIndentValueMinimale
      End If
      
      RTF.SelIndent = i
      SelIndentSub = True
End Function

'Aufzhlungszeichen
Public Function SelBullet() As Boolean

      With RTF
         If IsNull(.SelBullet) Then
            'nix oder falsch markiert
            Exit Function
         ElseIf .SelBullet = True Then
            .SelBullet = False
         Else
            .SelBullet = True
         End If
      End With
      
      SelBullet = True
End Function

'Ausrichtung links, rechts, zentriert
Public Sub SelAlign(Align As rtfAlignAttributs)

      If RTF.SelLength = 0 Then
         Exit Sub
      End If

      Select Case Align
         Case rtfAlignLeft
            RTF.SelAlignment = rtfLeft
            
         Case rtfAlignRight
            RTF.SelAlignment = rtfRight
            
         Case rtfAlignCenter
            RTF.SelAlignment = rtfCenter
                     
         Case Else
      End Select
End Sub

'setzt Tabs, Beispiel: cRTF.SetTabs "30,60,90", vbMillimeters
Public Sub SetTabs(TabPos As Variant, ScaleMode As Long, _
                                      Optional DeleteTabsBefore As Boolean = True)

   Dim s() As String
   Dim i As Long, j As Long, k As Long
      
      If DeleteTabsBefore Then
         RTF.SelTabCount = 0
      End If
      
      s() = Split(TabPos, ",")
      For i = LBound(s) To UBound(s)
         j = RTF.SelTabCount + 1
         RTF.SelTabCount = j
         k = Val(s(i))
         RTF.SelTabs(j - 1) = RTF.Parent.ScaleX(k, ScaleMode, vbTwips)
      Next
End Sub

Private Sub Class_Initialize()

      mvarCatchTab = True        'Tab Taste einfangen
      mvarSelIndentValueStep = 20 * Screen.TwipsPerPixelX
      mvarSelIndentValueMinimale = 10 * Screen.TwipsPerPixelX
      Set CDLG = CreateObject("MSComDlg.CommonDialog")
End Sub

Private Sub Class_Terminate()

      Set CDLG = Nothing
End Sub

'Tastaturpuffer leeren
Private Sub RTF_GotFocus()
        
      LastKeyTabKey
End Sub

'Verlassen der Box durch Tab Taste verhindern
Private Sub RTF_Validate(Cancel As Boolean)

      If LastKeyTabKey = 0 Then
         Exit Sub
      End If
      
      'war Tab
      If mvarCatchTab Then
         'Fokusverlust unterbinden
         Cancel = True
         'Strg + Tab auslsen
         SendKeys "^{TAB}"
      End If
End Sub

'checken ob zuletzt an Tastatur Tab oder Shift Tab gedrckt
'Rckgabe: 1=Tab  2=Shift+Tab
Private Function LastKeyTabKey() As Long
      
   Dim key As tagWORD
      
      'berprfen TabTaste
      key = GetAsyncKeyState(VK_TAB)
      If key.lByte > 0 Then
         'Shift-Taste auch berprfen
         key = GetAsyncKeyState(VK_SHIFT)
         If key.hByte <> 0 Then
            LastKeyTabKey = 2
         Else
            LastKeyTabKey = 1
         End If
      Else
         LastKeyTabKey = 0
      End If
End Function


